package{

//--------------------------------------------------------------------//
// ŏS؃f[^
  public class MSTree{

// TCNԍ
    internal var cycle:Vector.<int>;

// ̒_
    internal var next:Vector.<int>;

// TCÑTCY
    internal var size:Vector.<int>;

//--------------------------------------------------------------------//
// count _̐
    public function MSTree(count:int){
      cycle=new Vector.<int>(count);
      next=new Vector.<int>(count);
      size=new Vector.<int>(count);
      for(var i:int=0;i<count;i++){
      	cycle[i]=i;
      	next[i]=i;
      	size[i]=1;
      }
    }

//--------------------------------------------------------------------//
// TCNǂԂ
// v1,v2 - _ԍ
    public function isCycle(v1:int,v2:int):Boolean{
      return (cycle[v1]!=cycle[v2]);
    }

//--------------------------------------------------------------------//
// TCNݒ肷
// v1,v2 - _ԍ
    public function setCycle(edge:Edge):void{
      if(size[cycle[edge.start]]>size[cycle[edge.end]]){
      	addCycle(edge.start,edge.end);
      }
      else{
      	addCycle(edge.end,edge.start);
      }
    }

//--------------------------------------------------------------------//
// TCN
// v1,v2 - _ԍ
    internal function addCycle(v1:int,v2:int):void{
      size[cycle[v1]]+=size[cycle[v1]];
      var v:int=v2;
      do{
      	cycle[v]=cycle[v1];
      	v=next[v];
      }while(v!=v2);
      v=next[v1];
      next[v1]=next[v2];
      next[v2]=v;
    }
  }
}
