package{
  import flash.display.Sprite;
  import flash.display.Stage;
  import flash.events.Event;
  import flash.events.KeyboardEvent;
  import flash.events.MouseEvent;
  import flash.ui.Keyboard;
  import flash.text.TextFormat;
  import component.Button;
  import component.ComboBox;

//--------------------------------------------------------------------//
// ANVǗNX
  public class VoronoiActionManager{

// Xe[W
    internal var stage:Stage;

// {mC}\f
    internal var view:VoronoiViewModel;

// }EX{^Ă邩ǂ
    internal var pressed:Boolean;

// }EXʒu
    internal var mx:int;
    internal var my:int;

// \}ؑփR{{bNX
    internal var type:ComboBox;

//--------------------------------------------------------------------//
// sprite - eXvCg
// view - {mC}\f
// x,y,width - \ʒuA
// textFormat - eLXg
    public function VoronoiActionManager(sprite:Sprite,
      	      	      	      	      	 view:VoronoiViewModel,
      	      	      	      	      	 x:int,y:int,width:int,
      	      	      	      	      	 textFormat:TextFormat){
      stage=sprite.stage;
      this.view=view;
      stage.addEventListener(MouseEvent.MOUSE_DOWN,mousePressed);
      stage.addEventListener(MouseEvent.MOUSE_UP,mouseReleased);
      stage.addEventListener(KeyboardEvent.KEY_DOWN,keyPressed);
      pressed=false;
      mx=0;
      my=0;
      addButtons(sprite,x,y,width,textFormat);
    }

//--------------------------------------------------------------------//
// {^ǉ
// sprite - eXvCg
// x,y,width - \ʒuA
// textFormat - eLXg
    internal function addButtons(sprite:Sprite,x:int,y:int,
      	      	      	      	 width:int,textFormat:TextFormat):void{
      var bgColor:uint=0xffffff;
      var fgColor:uint=0x000000;

      var w:int=width/3;
      type=new ComboBox(VoronoiModel.TYPE_NAME,fgColor,bgColor,x,y,
      	      	      	textFormat,ComboBox.ABOVE,view.viewType);
      var drawButton:Button=new Button("draw",fgColor,bgColor,
      	      	      	      	       x+w,y,textFormat);
      var clearButton:Button=new Button("clear",fgColor,bgColor,
      	      	      	      	        x+2*w,y,textFormat);

      type.addEventListener(ComboBox.SELECT,changeType);
      drawButton.addEventListener(MouseEvent.CLICK,draw);
      clearButton.addEventListener(MouseEvent.CLICK,clear);

      sprite.addChild(type);
      sprite.addChild(drawButton);
      sprite.addChild(clearButton);
    }

//--------------------------------------------------------------------//
// }EX{^̏s
    internal function mousePressed(event:MouseEvent):void{
      pressed=true;
      mx=stage.mouseX;
      my=stage.mouseY;
      view.addPoint(mx,my);
    }

//--------------------------------------------------------------------//
// }EX{^𗣂̏s
    internal function mouseReleased(event:MouseEvent):void{
      pressed=false;
    }

//--------------------------------------------------------------------//
//L[̏s
    internal function keyPressed(event:KeyboardEvent):void{
      switch(event.keyCode){
      	case Keyboard.NUMPAD_5:
      	case Keyboard.NUMBER_5:
      	case Keyboard.C:
      	  view.draw();
      	  break;
      	case Keyboard.D:
      	  view.clear();
      	  break;
      }
    }

//--------------------------------------------------------------------//
// }`悷
    internal function draw(event:Event):void{
      view.createGraph();
    }

//--------------------------------------------------------------------//
// \
    internal function clear(event:Event):void{
      view.clear();
    }

//--------------------------------------------------------------------//
// \}؂ւ
    internal function changeType(event:Event):void{
      if(view.viewType==type.index) return;
      view.setType(type.index);
    }
  }
}
